import * as t from '@babel/types';
import { addSideEffect } from '@babel/helper-module-imports';
import compileLess from './less-compile';
export default function () {
  return {
    visitor: {
      Program: {
        enter: function enter(_path, _ref) {
          var opts = _ref.opts;
          compileLess(opts.src, opts.output);
        },
        exit: function exit() {}
      },
      ImportDeclaration: function (_ImportDeclaration) {
        function ImportDeclaration(_x) {
          return _ImportDeclaration.apply(this, arguments);
        }

        ImportDeclaration.toString = function () {
          return _ImportDeclaration.toString();
        };

        return ImportDeclaration;
      }(function (path) {
        var _source$value;

        var _path$node = path.node,
            specifiers = _path$node.specifiers,
            source = _path$node.source;
        var isValid = specifiers.length === 1 && t.isImportDefaultSpecifier(specifiers[0]) && ((_source$value = source.value) === null || _source$value === void 0 ? void 0 : _source$value.endsWith('.module.less'));

        if (!isValid) {
          return;
        }

        addSideEffect(path, source.value.replace('less', 'css'));
        source.value = source.value.replace('less', 'css.js');
      })
    }
  };
}